from forum.decorators import login_required_async
from urllib.request import BaseHandler
from forum import manager
from forum.handler.BaseHandler import BaseHandler
from forum.models import TopicModel,UserModel,CollectionModel


class AddCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        #获取前端传递的文章id
        topic_id = self.get_body_argument('id')
        #根据文章id获取文章信息
        topic = await manager.get(TopicModel,id = topic_id)
        #获取用户信息   _user_id登录才有
        user = await manager.get(UserModel,id=self._user_id)
        #创建对象并保存
        await manager.create(CollectionModel,topic = topic,user = user)
        self.finish({'code':200,'msg':'收藏成功！'})        


#76
# class GetMyCollectionHandler(BaseHandler):
#     @login_required_async
#     async def post(self):
#         #通过id获取收藏信息
#         collection = manager.execute(CollectionModel.select().join(UserModel.id == self._user_id))
#         data = []
#         for c in collection:
#             tc = c.to_json()
#             tc['user'] = c.user.to_json()
#             tc['topic']=c.topic.to_json()
#             #删除不要的信息
#             del tc['topic']['user']
#             del tc['topic']['imgs']
#             del tc['topic']['content']
#             #追加信息
#             data.append(tc)
#         self.finish({'code':200,'msg':'获取个人收藏信息成功','collection':data})   #'collection'展示新的内容
class GetMyCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        # 通过userId获取收藏的信息
        collection = await manager.execute(CollectionModel.select().join(UserModel).where(UserModel.id == self._user_id))
        data = []
        for c in collection:
            tc = c.to_json()
            tc['user'] = c.user.to_json()
            tc['topic'] = c.topic.to_json()
            del tc['topic']['user']
            del tc['topic']['imgs']
            del tc['topic']['content']
            data.append(tc)
        self.finish({'code':200,'msg':'获取个人收藏成功!','collection':data})

#77 删收藏
class DeleteMyCollectionHandler(BaseHandler):
    @login_required_async
    async def post(self):
        #通过前端传来的id获取文章id
        topic_id = self.get_body_argument('id')
        #通过userid获取用户 get和 excuete都行
        user = await manager.get(UserModel,id = self._user_id)
        #通过文章id获取帖子
        topic = await manager.get(TopicModel,id = topic_id)
        #通过userid进行删除
        rs = await manager.execute(CollectionModel.delete().where(CollectionModel.user == user,CollectionModel.topic == topic))
        if rs > 0:
            self.finish({'code':200,'msg':'删除收藏成功'})   
        else:
            self.finish({'code':500,'msg':'删除收藏失败'})               
