from forum.handler.BaseHandler import BaseHandler
from forum import manager
from forum.models import UserModel,TopicModel,CommentModel
from forum.decorators import login_required_async
from uuid import uuid4

#71
class GetCommentHandler(BaseHandler):
    async def post(self):
        rs_data ={}
        id = self.get_body_argument('id')
        #根据帖子id获取所有的评论
        comments =await manager.execute(CommentModel.select().join(TopicModel).where(TopicModel.id == id))
        data = []
        #遍历评论 转为json
        for c in comments:
            tc = c.to_json()#把评论转为json
            tc['user'] =c.user.to_json()#往转化成json的数据增加user属性
            del tc['topic']
            data.append(tc)
        rs_data['code'] = 200
        rs_data['msg'] = '获取评论成功'
        rs_data['comments'] = data
        #给前端返回具体数据
        self.finish(rs_data)

#72  发表评论
class AddCommentHandler(BaseHandler):
    @login_required_async
    async def post(self):
        content = self.get_body_argument('content')
        topic_id = self .get_body_argument('topic_id')
        #获取帖子对象信息  异步的获取
        topic = await manager.get(TopicModel,id = topic_id)
        #获取用户对象信息   _user_id这个参数登录才有
        user = await manager.get(UserModel,id = self._user_id)
        #创建一个comment 对象
        await manager.create(CommentModel,id = uuid4(),content = content,topic = topic,user = user)
        #给前端返回具体数据  这样的msg有提示效果
        self.finish({'code':200,'msg':'评论成功！'})

#73 获取个人评论
class GetMyCommentHandler(BaseHandler):
    @login_required_async
    async def post(self):
        #获取评论                                                                 UserModel里面的id
        comments = await manager.execute(CommentModel.select().join(UserModel).where(UserModel.id == self._user_id))
        #建立一个列表 来存储所有的json评论shuj
        data = []
        #遍历数据转为json
        for c in comments:
            tc = c.to_json()
            tc['user'] = c.user.to_json()
            del tc['topic']
            data.append(tc)
        self.finish({'code':200,'msg':'获取个人评论成功！','comments':data})

#自己编写删除评论功能 成功
class DeleteMyComment(BaseHandler):
    #先登录
    @login_required_async
    #用异步函数
    async def post(self):
        #通过前端传来的commentID获取文章的id  ok
        comment_id = self.get_body_argument('commentID')
        # print(comment_id)
        '''
        #下面两句代码多余，还会报错
        #通过userid查询用户 get和 excuete都行 ok
        user = await manager.get(UserModel,id = self._user_id)
        print(user)
        #通过评论的id获取文章
        topic = await manager.get(TopicModel,topic = comment_id)
        print(topic)
        '''
        #通过userid进行删除
        rs = await manager.execute(CommentModel.delete().where(CommentModel.id == comment_id))
        print(rs)       
        if rs > 0:
            self.finish({'code':200,'msg':'删除评论成功'})   
        else:
            self.finish({'code':500,'msg':'删除评论失败'})    

