from forum.handler.BaseHandler import BaseHandler
from forum import manager
from forum.models import UserModel,FollowModel
from forum.decorators import login_required_async
from json import loads

# 80
class AddFollowHandler(BaseHandler):
    @login_required_async
    async def post(self):
        #解决已经关注再关注要求登录的bug
        try:
            #获取关注用户的id
            uid = self.get_body_argument('id')
            #异步获取数据
            to_user = await manager.get(UserModel,id = uid)
            #获取自己的id
            from_user = await manager.get(UserModel,id = self._user_id)
            #增加关注关系
            await manager.create(FollowModel,to_user= to_user,from_user = from_user)
            #返回一条信息
            self.finish({'code':200,'msg':'关注成功'})
        except Exception as e:
            self.finish({'code':500,'msg':'关注失败'})

'''
这个函数包含两个方法
'''
# 81 获取关注状态  
class GetFollowHandler(BaseHandler):
    @login_required_async
    async def post(self):
        try:
            #获取关注的用户的id
            uid = self.get_body_argument('id')
            #获取自己的id
            fid = self._user_id
            #在数据库查询是否已关注
            '''
            await manager.execute(FollowModel.select().wherw(FollowModel.to_user == uid,FollowModel.from_user == fid))
            表示在FollowModel里面执行sql语句
            '''
            follow = await manager.execute(FollowModel.select().where(FollowModel.to_user == uid,FollowModel.from_user == fid))
            #如果有值
            if follow:
                self.finish({'code':200,'msg':'已关注','flag':True})
            else:
               self.finish({'code':500,'msg':'未关注','flag':False})     
        except Exception as e:
            print(e)
            self.finish({'code':500,'msg':'未关注','flag':False})        
 
    #83获取我的关注
    @login_required_async
    async def get(self):
        #user.id pic nick_name create_time前端传来的四个shuj         on=FollowModel.to_user表示关联这个表的这个字段 
        follows = await manager.execute(FollowModel.select(FollowModel.create_time,UserModel.id,UserModel.pic,UserModel.nick_name).join(UserModel,on=FollowModel.to_user).where(FollowModel.from_user == self._user_id))
        #    FollowModel继承BaseModel 他有这个字段create_time           UserModel.id,UserModel.pic,UserModel.nick_name 表示这个表的这三个字段        
        #     83第九分钟
        '''
        data = []
        for f in follows._rows:
            #自己转化数据的操作 封装操作   这个要理解
            tf = {'create_time':str(f[0]),'id':f[1],'pic':f[2],'nick_name':f[3]}
            data.append(tf)
        '''
        #列表生成式
        data = [{'create_time':str(f[0]),'id':f[1],'pic':f[2],'nick_name':f[3]} for f in follows._rows]
        #代码的优化
        self.finish({'code':200,'msg':'获取关注列表成功','friends':data})        

       

#82取消关注
# class DeleteFollowHandler(BaseHandler):
#     @login_required_async
#     async def delete(self):
#         #转化数据再传进data  self.request.body表示请求体传来的数据
#         data = loads(self.request.body)
#         uid = data.get('id')
#         to_user = await manager.get(UserModel,id =uid)
#         from_user = await manager.get(UserModel,id =self._user_id)
#         rs = await manager.execute(FollowModel.delete().where(FollowModel.to_user == to_user,FollowModel.from_user == from_user))
#         self.finish({'code':200,'msg':'取消关注成功'})


#82另外的写法
class DeleteFollowHandler(BaseHandler):
    @login_required_async
    async def delete(self):
        try:
            #转化数据再传进data  self.request.body表示请求体传来的数据
            data = loads(self.request.body)
            uid = data.get('id')
            to_user = await manager.get(UserModel,id =uid)
            from_user = await manager.get(UserModel,id =self._user_id)
            rs = await manager.execute(FollowModel.delete().where(FollowModel.to_user == uid,FollowModel.from_user == self._user_id))
            self.finish({'code':200,'msg':'取消关注成功'})
        except Exception as e:
            self.finiseh({'code':500,'msg':'取消关注失败'})

#视频84
class FollowNumHandler(BaseHandler):
    @login_required_async
    async def post(self):
        #to  关注数 关注谁
        #form 粉丝数  谁关注我
        #前端程序给的字段type_
        type_ = self.get_body_argument('type_')
        #获取关注数
        if type_ =='to':
            #                                    视频84的09.00讲解   from_user == self._user_id)表示from_user的id等于自己的id
            to_user =await manager.execute(FollowModel.select().where(FollowModel.from_user == self._user_id))
            self.finish({'code':200,'msg':'获取关注数量成功','num':len(to_user._rows)})
        #获取自己的粉丝数
        elif type_ == 'from':
            from_user =await manager.execute(FollowModel.select().where(FollowModel.to_user == self._user_id))
            self.finish({'code':200,'msg':'获取关注数量成功','num':len(from_user._rows)})