'''
两套项目
默认支持自己内容访问
前端项目：3000   后端项目：8000
跨域访问-允许
'''
from uuid import uuid4
from random import randint

import jwt#jwt.io网址  加密的模块

from tornado.web import RequestHandler#继承这个
from forum.wtforms import UserForm,LoginUserForm,UpdateUserForm#验证模块
from forum.models import UserModel
from forum import manager
from forum.handler.BaseHandler import BaseHandler
from forum.utils.email_util import send_email,zmail#发送邮件的方法
from forum.utils.redis_util import get_code,save_code
# from forum.utils.redis_util import *  和上面的一样
from config import email,secret,settings
from forum.decorators import login_required_async
import os


#BaseHandler继承RequestHander，同时它自己设置跨域
class AddUserHandler(BaseHandler):  
    #因为要改变数据防止io所以用异步
    async def post(self):#接收请求的参数并封装到Form对象中
        rs_data = {}#创建一个响应对象
        #这是UserForm的参数?
        user_form = UserForm(self.request.arguments)
        #获取验证码
        '''
        #前端传递的验证码  从哪里传过来的code
        code是前端注册页面的code字段
        '''
        code=self.get_body_argument('code')       
        #服务器端通过用户传递的user_form.email.data来保存的验证码
        db_code = get_code(user_form.email.data)
        #比较验证码 验证码通过就注册
        if code ==db_code:
        #对数据进行验证
            if user_form.validate():
                #验证通过保存数据 返回一个信息
                #验证用户名是不是唯一
                email= user_form.email.data#email地址获取方法
                try:
                    #从数据库中查数据
                    exist_user = await manager.get(UserModel,email=email)
                    if exist_user:#已经存在
                        #如果存在就说已经注册
                        rs_data['code'] = 500
                        rs_data['msg'] = '用户已经存在'                                  
                except Exception as e:
                    #设置唯一的id
                    user_form.id.data = uuid4()
                    #不存在就说可以注册 异步处理 要修改io
                    await manager.create(UserModel,**user_form.data)
                    rs_data['code'] = 200
                    rs_data['msg'] = '注册成功'
            else:
                #注册失败不会提示什么失败 可以自己定义一个elif来输出错误
                rs_data['code'] = 500
                rs_data['msg'] = '注册失败'
                #比较完善的错误信息提示  可以再控制台输入user_form.errors查看
                #user_form.errors错误信息在user_form.errors
                for f in user_form.errors:
                    #例如是email错误 就会输出user_form的错误字段email获取它的key再获取第0个字段  解释视频46 第12分钟
                    rs_data[f]=user_form.errors[f][0]
        else:
            #如果对比不符合就显示失败
            rs_data['code'] = 500
            rs_data['msg'] = '验证码错误'
        self.finish(rs_data)#返回这个信息

#开发发送邮件的接口  可以跨域
class SendEmailHandler(BaseHandler):
        #生成验证码的方法    int类型
    def generate_code(self) -> int:
        #random.randint(1000，9999) 随机生成1000-9999的四位数
        #random.choise('0123456789') 随机选一个数字出来 循环四次生成验证码
        #返回一个四位的数字
        return randint(1000,9999)

    def post(self):#post请求接收参数
        #获取前端网页的email参数
        user_email = self.get_body_argument('email')
        code = self.generate_code()
        msg = f'您好，您正在使用{user_email}进行<尚学堂-CMS项目>用户注册，您的验证码为{code},如果非本人操作请忽略邮件！'
        
        #动态获取数据     谁获取负责发送     获取密码         发给谁        类型   标题         内容
        #优化：怎么将账号密码写到python的环境变量中？
        #发送验证码的方法，form_email = email.get('uname')，to_email = user_email，因为send_email定义好要传送什么参数
        #uname和pwd  是 config定义好的email属性
        send_email(email.get('uname'),email.get('pwd'),user_email,'<尚学堂-CMS项目>用户注册',msg)       
        
        #调用保存验证码到数据库的方法  传入参数user_email和code
        save_code(user_email,code)


#登录的功能  视频52
class LoginHandler(BaseHandler):
    #前端传送的参数是email 和 password
    async def post(self):#通过post请求获取数据
        rs_data ={}
        #利用LoginUserForm的约束条件来创建对象
        user_form = LoginUserForm(self.request.arguments)#self.request.arguments前端传递参数？
        if user_form.validate():#验证成功                       
            try:
                 #从获取数据库中获取用户信息  email和password从user_form中获取  因为前端传来这两个参数
                user = await manager.get(UserModel,email=user_form.email.data,password= user_form.password.data)
                #获取到了，登录成功 输出信息
                rs_data['code'] =200
                rs_data['msg'] ='登录成功'   
                #视频53  生成一个加密的用户信息 反馈给前端 下次登录携带信息
                paylod = {
                    'email':user_form.email.data#把参数传递过去
                } 
                #数据加密          加密的数据   加密的密码    算法
                token = jwt.encode(paylod,secret,algorithm="HS256")#加密paylod
                #sessionStorage.setItem("token",result.data.token)前端的代码是token
                #响应给html key定位
                rs_data['token']=token            
            except Exception as e:
                #获取不到
                rs_data['code'] =401
                rs_data['msg'] ='用户名或者密码错误'                
        #获取不到，登录失败，并输出错误信息
        else:
            #输出错误码和信息
            rs_data['code'] =401
            rs_data['msg'] ='用户名不符合规范'
            #做一个友好的错误输出 知道哪里错
            for f in user_form.errors:
                # rs_data的第[f]个字段
                rs_data[f] = user_form.errors[f][0]
        #最后返回一个成功信息
        self.finish(rs_data)

'''
#定义一个通过token获取用户状态  55视频
class GetUserHandler(BaseHandler):
    async def get(self):
        rs_data={}#定义一个空的内容
        #获取token   token在请求头里面
        token = self.request.headers.get('token')
        #通过token 解析email   给谁用什么盐 用什么方法解密
        payload = jwt.decode(token, secret, algorithms=["HS256"])
        if payload:
            #通过email查询数据
            email = payload.get('email')
            #异步的查询  通过manager以get请求获取UserModel和email
            user = await manager.get(UserModel,email=email)
            #判断是不是有数据
            if user:
            #有数据 将用户信息返回给前端
                rs_data['code'] =200
                rs_data['msg'] ='获取用户成功'
                #返回用户信息  有一个key叫user key一定要一致
                rs_data['user']=user.to_json()
            #没有数据 没有登录
            else:
                rs_data['code'] =500
                rs_data['msg'] ='token错误！'
        #没有email就是登录
        else:
            rs_data['code'] =500
            rs_data['msg'] ='请登录后操作'

        self.finish(rs_data)
'''

#通过装饰器来改写方法
class GetUserHandler(BaseHandler):
    @login_required_async
    async def get(self):
        rs_data={}#定义一个空的内容
        #进行表单验证
        user_form = LoginUserForm(self.request.arguments)
        #获取id
        id = self._user_id
        try:
            #异步的查询  通过manager以get请求获取UserModel和id
            user = await manager.get(UserModel,id=id)
            #判断是不是有数据
            if user:
            #有数据 将用户信息返回给前端
                rs_data['code'] =200
                rs_data['msg'] ='获取用户成功'
                #返回用户信息  有一个key叫user key一定要一致
                rs_data['user']=user.to_json()
        except Exception as e:
                rs_data['code'] =500
                rs_data['msg'] ='获取用户信息错误！' 
                #做一个友好的错误输出 知道哪里错
                for f in user_form.errors:
                    # rs_data的第[f]个字段
                    rs_data[f] = user_form.errors[f][0]           
        #返回rs_data
        self.finish(rs_data)


#59更新用户  post请求
class UpdateUserHandler(BaseHandler):
    async def post(self):
        #进行表单验证
        user_form = LoginUserForm(self.request.arguments)
        #创建一个rs_data
        rs_data = {}
        #             self.request.arguments前端传来的参数      
        user_form = UpdateUserForm(self.request.arguments)
        #验证
        if user_form.validate():
            #id email password不更新
            #数据更新之后前后有空格 去空格操作
            user_form.email.data = user_form.email.data.strip()
            #更新    **user_form.data这里表示所有的数据传进去
            #获取前端传来的id
            id=user_form.id.data
            #视频60  保存头像  获取头像文件数据
            pic = self.request.files.get('pic',[{}])[0]#通过请求过来的读取参数
            #因为有多个用户上传头像，为避免图像文件名重复 所以随机生成一个
            file_name = uuid4().hex
            #获取源文件的后缀名  splitext表示分割文件名和后缀
            # file_suffix = os.path.splitext(pic.get('filename'))[-1]
            file_suffix = os.path.splitext(pic.get('filename'))[-1]
            #完整的文件名
            full_name = file_name + file_suffix
            #为了保证用户可以访问自己上传的图像 所以保存在静态文件中  追加方式添加路径 放到img文件中
            full_path = os.path.join(settings.get('static_path'),'img',full_name)            
            #保存图像  
            #
            with open(full_path,'wb') as f:
                #表示写入pic的body属性
                f.write(pic.get('body')) 
            # print(full_path)
            
            #视频61 更新用户的头像地址
            user_form.pic.data = os.path.join('/static/img',full_name)

            
            #根据id更新数据
            rs = await manager.execute(UserModel.update(**user_form.data).where(UserModel.id == id))
            if rs>0:
                rs_data['code'] =200
                rs_data['msg'] ='更新成功'  
            else:
                rs_data['code'] =500
                rs_data['msg'] ='更新失败'                   
        else:
            rs_data['code'] =500
            rs_data['msg'] ='数据不合法'   
            #做一个友好的错误输出 知道哪里错
            for f in user_form.errors:
                # rs_data的第[f]个字段
                rs_data[f] = user_form.errors[f][0]     
        #返回
        self.finish(rs_data)  