# 总路由映射
from typing import Collection
from forum.handler import BaseHandler,UserHandler,TopicHandler,CommentHandler,CollectionHandler,FollowHandler


handlers = [
    #写接口的方法，url要一样
    ('/',BaseHandler.IndexHandler),
    ('/api/user/add/?',UserHandler.AddUserHandler),#对跨域设置路由
    #Request URL: http://localhost:3000/api/send_msg点击注册发送信息到这个url
    ('/api/send_msg/?',UserHandler.SendEmailHandler),#这个地址用这个方法
    ('/api/user/login/?',UserHandler.LoginHandler),#这个地址用这个方法
    ('/api/user/get/?',UserHandler.GetUserHandler),
    ('/api/user/update/?',UserHandler.UpdateUserHandler),
    ('/api/topic/all/?',TopicHandler.GetManyTopicHandler),#视频63显示主页帖子
    ('/api/topic/id/?',TopicHandler.GetOneTopicHandler),#视频64 
    ('/api/topic/add/?',TopicHandler.AddTopicHandler),#视频67
    ('/api/topic/my/?',TopicHandler.GetMyTopicHandler),#视频69 获取个人帖子信息
    ('/api/comment/get/tid/?',CommentHandler.GetCommentHandler),#视频71 获取个人评论信息
    ('/api/comment/add/?',CommentHandler.AddCommentHandler),#视频72 发表评论信息
    ('/api/comment/my/?',CommentHandler.GetMyCommentHandler),#视频73 获取个人评论信息
    ('/api/collection/add/?',CollectionHandler.AddCollectionHandler),#视频75 增加帖子收藏功能
    ('/api/collection/my/?',CollectionHandler.GetMyCollectionHandler),#视频76 查看帖子收藏功能
    ('/api/collection/delete/?',CollectionHandler.DeleteMyCollectionHandler),#视频77 删除收藏的帖子
    ('/api/follow/add/?',FollowHandler.AddFollowHandler),#视频80 关注模块
    ('/api/follow/judge/?',FollowHandler.GetFollowHandler),#视频81
    ('/api/follow/delete/?',FollowHandler.DeleteFollowHandler),#视频82
    ('/api/follow/get/?',FollowHandler.GetFollowHandler),#视频83 获取我的关注
    ('/api/follow/num/?',FollowHandler.FollowNumHandler),#视频84 获取关注粉丝数
    ('/api/delete/myComment/?',CommentHandler.DeleteMyComment),#自己编写删除评论的功能
    ('/api/get/hostPost/?',TopicHandler.HotPostHandler),#自己编写热帖的功能
    ('/api/delete/myTopic/?',TopicHandler.DeleteMyTopicHandler),#自己编写删除热帖的功能
]